## libnxt 0.3

=== SConstruct ===
from glob import glob

auto_libs = ''

# Detect the system's endianness
from sys import byteorder
if byteorder == 'big':
	endian = '_NXT_BIG_ENDIAN'
else:
	endian = '_NXT_LITTLE_ENDIAN'

BuildEnv = Environment(CCFLAGS=['-Wall', '-std=gnu99',
				'-g', '-ggdb', '-D' + endian])
if auto_libs:
	BuildEnv.ParseConfig('pkg-config --cflags --libs ' + auto_libs)

BuildEnv.Command('flash_routine.h',
		 'flash_routine.h.base',
		 './make_flash_header.py')

Default(BuildEnv.Library('nxt',
			 [x for x in glob('*.c')
			  if not x.startswith('main_')],
			 LIBS='usb'))

Default(BuildEnv.Program('fwflash', 'main_fwflash.c',
			 LIBS=['usb', 'nxt'], LIBPATH='.'))

Default(BuildEnv.Program('fwexec', 'main_fwexec.c',
			 LIBS=['usb', 'nxt'], LIBPATH='.'))

=== flash_write/Makefile ===
#all:
#	gcc -Wall -O0 -mcpu=arm7tdmi-s -mapcs -mthumb-interwork -o flash.o flash.c -nostartfiles -nodefaultlibs -nostdlib -Wl,-e,main
#	objcopy -Obinary -j.text flash.o flash.bin
#	objdump --disassemble-all -bbinary -marm7tdmi flash.bin > flash.asm
#

CC=`which arm-elf-gcc`
AS=`which arm-elf-as`
LD=`which arm-elf-ld`
OBJCOPY=`which arm-elf-objcopy`

all:
	$(CC) -W -Wall -O3 -msoft-float -mcpu=arm7tdmi -mapcs -c -o flash.o flash.c
	$(AS) --warn -mfpu=softfpa -mcpu=arm7tdmi -mapcs-32 -o crt0.o crt0.s
	$(LD) -O3 --gc-sections crt0.o flash.o -o flash.elf
	$(OBJCOPY) -O binary flash.elf flash.bin

clean:
	rm -f flash.o crt0.o flash.elf flash.bin

=== debian/changelog ===
libnxt (0.3-2) unstable; urgency=low

  * Fix the order of passed libraries, thanks to Felix Geyer
    (Closes: #706497)
  * Small fix of the package description
  * Upload sponsored by Petter Reinholdtsen.

 -- Slavko <linux@slavino.sk>  Wed, 01 May 2013 11:29:24 +0200

libnxt (0.3-1) unstable; urgency=low

  * Initial release (Closes: #697404)
  * Upload sponsored by Petter Reinholdtsen.

 -- Slavko <linux@slavino.sk>  Fri, 11 Jan 2013 15:48:07 +0100

=== debian/control ===
Source: libnxt
Section: electronics
Priority: extra
Maintainer: Slavko <linux@slavino.sk>
Build-Depends: debhelper (>= 8), libusb-dev (>= 0.1.12), scons (>= 1.2)
Standards-Version: 3.9.4
Homepage: http://code.google.com/p/libnxt

Package: libnxt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utility library for talking to the LEGO Mindstorms NXT brick
 LibNXT is an utility library for talking to the LEGO Mindstorms NXT intelligent
 brick at a relatively low level. It currently does:
  * Handling USB communication and locating the NXT in the USB tree.
  * Interaction with the Atmel AT91SAM boot assistant.
  * Flashing of a firmware image to the NXT.
  * Execution of code directly in RAM.
 .
 The design of LibNXT is layered, meaning you can plug into it at any level of
 complexityor abstraction you desire, from the lowest level USB bulk bit-pushing
 interface, to an API exposing the SAM-BA commandset, right up to just calling
 nxt_firmware_flash() and having everything taken care of! 
 .
 This package provides two binary utils:
  * fwflash is the program that uses LibNXT. As its name hints, its purpose is
    to take a NXT firmware image file and flash it to a connected NXT device.
  * fwexec is another utility, which takes a specially compiled firmware image,
   uploads it to the NXT's RAM, and executes it directly from there.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	scons LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" CCFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)"

override_dh_auto_clean: 
	dh_auto_clean
	scons -c
	rm -f .sconsign.dblite || true

%:
	dh  $@

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Uncomment to find new files on GooglePages
#http://code.google.com/p/libnxt/downloads/list http://libnxt.googlecode.com/files/libnxt-(.*)\.tar\.gz

opts=downloadurlmangle=s#.*(libnxt-([\d.]+)\.tar\.gz).*#http://libnxt.googlecode.com/files/$1#,filenamemangle=s#.*(libnxt-([\d.]+)\.tar\.gz).*#$1# \
    http://code.google.com/p/libnxt/downloads/list ^.*detail\?name=libnxt-([\d.]+)\.tar\.gz.*

## libnxt 0.4.2

=== meson_options.txt ===
option('build_doc', type : 'feature', value : 'auto',
  description : 'Build man pages')

=== debian/changelog ===
libnxt (0.4.2-1) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * New upstream version 0.4.2
    - Drop obsolete Debian specific manual pages replaced by
      upstream ones.

  [ Nicolas Schodet ]
  * Add autopkgtest, test NXT detection by simulating the NXT brick.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 29 Oct 2021 14:50:03 +0200

libnxt (0.4.1-2) unstable; urgency=medium

  [ Nicolas Schodet ]
  * Add missing pkg-config dependency.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 23 Oct 2021 19:14:30 +0200

libnxt (0.4.1-1) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * Switched appstream metadata license back to MIT and adjusted d/copyright.
  * Marked package to not need root access during build.
  * Switched patches to new naming scheme.
  * Adjusted d/rules and 1050-ldflags-command-line.patch to build
    hardened binaries.

  [ Nicolas Schodet ]
  * Moved to new upstream. (Closes: #830201)
  * New upstream version 0.4.1 (Closes: #810440)
  * Dropped patches which are no longer needed.
  * Updated build system and dependencies.
  * Restrict USB product identifier to the one used by NXT in SAM-BA mode.
    (Closes: #877297)

  [ Petter Reinholdtsen ]
  * Added Nicolas Schodet as uploader.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 22 Oct 2021 21:38:37 +0200

libnxt (0.3-11) unstable; urgency=medium

  * Added 1040-ccflags-command-line.patch to fix one reproducible
    build issue.
  * Added 1050-ldflags-command-line.patch to improve binary
    fortification.
  * Converted d/watch to a no-op version documenting upstream is
    missing.
  * Dropped no longer working home page url from d/control.
  * Moved to debhelper-compat dependency.
  * Changed license of appstream metainfo file to match license in
    d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 02 Oct 2021 07:28:55 +0200

libnxt (0.3-10) unstable; urgency=medium

  * Updated Standards-Version from 4.0.0 to 4.6.0.
  * Removed useless trailing space from d/rules.
  * Updated debhelper compat level to 13.
  * Added 1030-double-const.patch to fix build problems.
  * Switch appstream metadata ID to reverse domain-name.
  * Changed package priority from obsolete extra to optional.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 26 Sep 2021 22:54:53 +0200

libnxt (0.3-9.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add patch from Hugh McMaster fixing building with Python 3 SCons.
    (Closes: #947567)

 -- Adrian Bunk <bunk@debian.org>  Wed, 12 Feb 2020 12:29:51 +0200

libnxt (0.3-9) unstable; urgency=medium

  * Correct content of d/compat to list level 9, not level 8.
  * Remove redundant code in d/rules.
  * Corrected install path for appstream metadata to /usr/share/metainfo/.
  * Updated Standards-Version from 3.9.8 to 4.0.0.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 01 Aug 2017 10:05:24 +0200

libnxt (0.3-8) unstable; urgency=medium

  [ Dominik George ]
  * Use secure VCS URL.
  * Add AppStream provides for NXT in flash mode.
  * Recommend new nxt-firmware package.
  * Add myself to uploaders.

  [ Petter Reinholdtsen ]
  * Corrected section in d/gbp.conf.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 25 Oct 2016 12:21:44 +0000

libnxt (0.3-7) unstable; urgency=medium

  * Added d/gbp.conf to enforce use of pristine-tar.
  * Fixed typo in udev rule breaking it for everyone (== -> =).

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 19 Oct 2016 08:34:28 +0000

libnxt (0.3-6) unstable; urgency=medium

  * Moved package under the new Debian LEGO Team umbrella and publish
    git repo there.
  * Added udev marker ID_LEGO_MINDSTORMS in udev rule.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 09 Oct 2016 06:28:02 +0000

libnxt (0.3-5) unstable; urgency=medium

  * QA upload
  * Adjusted udev rule, made sure to use tag uaccess for console user
    access using logind.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 06 Oct 2016 19:36:22 +0000

libnxt (0.3-4) unstable; urgency=medium

  * QA upload
  * Made sure to install the appstream metadata file.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 24 Sep 2016 04:43:59 +0000

libnxt (0.3-3) unstable; urgency=medium

  * QA upload
  * Changed maintainer to Debian QA team as package is orphaned.
  * Updated Standards-Version from 3.9.4 to 3.9.8.
  * Changed to debhelper 9.
  * Added appstream info announcing support for the Lego Mindstorms NXT.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 17 Sep 2016 10:27:42 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,28 @@
 Source: libnxt
 Section: electronics
-Priority: extra
-Maintainer: Slavko <linux@slavino.sk>
-Build-Depends: debhelper (>= 8), libusb-dev (>= 0.1.12), scons (>= 1.2)
-Standards-Version: 3.9.4
-Homepage: http://code.google.com/p/libnxt
+Priority: optional
+Maintainer: Debian LEGO Team <debian-lego-team@lists.alioth.debian.org>
+Uploaders:
+ Petter Reinholdtsen <pere@debian.org>,
+ Dominik george <nik@naturalnet.de>,
+ Nicolas Schodet <nico@ni.fr.eu.org>,
+Build-Depends:
+ debhelper-compat (= 13)
+ , libusb-1.0-0-dev
+ , meson
+ , scdoc
+ , pkg-config
+ , gcc-arm-none-eabi
+Standards-Version: 4.6.0
+Homepage: https://git.ni.fr.eu.org/libnxt.git/about/
+Vcs-Git: https://salsa.debian.org/debian-lego-team/libnxt.git
+Vcs-Browser: https://salsa.debian.org/debian-lego-team/libnxt
+Rules-Requires-Root: no
 
 Package: libnxt
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: nxt-firmware
 Description: utility library for talking to the LEGO Mindstorms NXT brick
  LibNXT is an utility library for talking to the LEGO Mindstorms NXT intelligent
  brick at a relatively low level. It currently does:
@@ -20,7 +34,7 @@
  The design of LibNXT is layered, meaning you can plug into it at any level of
  complexityor abstraction you desire, from the lowest level USB bulk bit-pushing
  interface, to an API exposing the SAM-BA commandset, right up to just calling
- nxt_firmware_flash() and having everything taken care of! 
+ nxt_firmware_flash() and having everything taken care of!
  .
  This package provides two binary utils:
   * fwflash is the program that uses LibNXT. As its name hints, its purpose is

=== debian/tests/control ===
Tests: nxt-found
Depends: @, umockdev (>= 0.16.3)

=== debian/watch ===
version=4
opts="mode=git, pgpmode=gittag" \
	https://git.ni.fr.eu.org/libnxt.git refs/tags/([\d\.]+) debian uupdate

## libnxt 0.5.2

=== debian/changelog ===
libnxt (0.5.2-1) unstable; urgency=medium

  * Add tests for firmware validity checks.
  * New upstream version 0.5.2.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Tue, 25 Feb 2025 23:12:42 +0100

libnxt (0.5.0-1) unstable; urgency=medium

  * Update upstream signing key.
  * New upstream version 0.5.0.
  * Update copyright information.
  * Update autopkgtest test.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Sat, 08 Feb 2025 23:12:10 +0100

libnxt (0.4.2-2) unstable; urgency=medium

  * Add upstream metadata.
  * Fix d/copyright, use https.
  * Rename metainfo file to match id.
  * Fix metainfo problems.
  * Change build dependency from pkg-config to pkgconf.
  * Update standards version to 4.7.0, no changes needed.
  * Tell blhc to ignore hardening rules for flash stub.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Fri, 18 Oct 2024 08:56:31 +0200

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  Dominik george <nik@naturalnet.de>,
  Nicolas Schodet <nico@ni.fr.eu.org>,
 Build-Depends:
- debhelper-compat (= 13)
- , libusb-1.0-0-dev
- , meson
- , scdoc
- , pkg-config
- , gcc-arm-none-eabi
-Standards-Version: 4.6.0
+ debhelper-compat (= 13),
+ libusb-1.0-0-dev,
+ meson,
+ scdoc,
+ pkgconf,
+ gcc-arm-none-eabi
+Standards-Version: 4.7.0
 Homepage: https://git.ni.fr.eu.org/libnxt.git/about/
 Vcs-Git: https://salsa.debian.org/debian-lego-team/libnxt.git
 Vcs-Browser: https://salsa.debian.org/debian-lego-team/libnxt
@@ -32,12 +32,12 @@
   * Execution of code directly in RAM.
  .
  The design of LibNXT is layered, meaning you can plug into it at any level of
- complexityor abstraction you desire, from the lowest level USB bulk bit-pushing
- interface, to an API exposing the SAM-BA commandset, right up to just calling
- nxt_firmware_flash() and having everything taken care of!
+ complexity or abstraction you desire, from the lowest level USB bulk
+ bit-pushing interface, to an API exposing the SAM-BA commandset, right up to
+ just calling nxt_firmware_flash() and having everything taken care of!
  .
  This package provides two binary utils:
   * fwflash is the program that uses LibNXT. As its name hints, its purpose is
     to take a NXT firmware image file and flash it to a connected NXT device.
   * fwexec is another utility, which takes a specially compiled firmware image,
-   uploads it to the NXT's RAM, and executes it directly from there.
+    uploads it to the NXT's RAM, and executes it directly from there.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_before_dh_auto_build:
	# No hardening for flash stub running on the NXT brick, tell blhc to
	# ignore it.
	@echo 'blhc: ignore-line-regexp: ^\[[0-9/]+\] [a-z/]*arm-none-eabi-.*'
	dh_auto_build

=== debian/tests/control ===
Tests: nxt-found, invalid-firmware, valid-firmware
Depends: @, xxd, umockdev (>= 0.16.3)
